module qsort_c_to_fortran
      use iso_c_binding
      integer, parameter :: sp = selected_real_kind(6)
      interface
      ! Write the Fortran interface to C qsort!
      ! void qsort(void *base, size_t nmemb, size_t size,
      !            int (*compar)(const void *, const void *));
      end interface
   contains
     integer(c_int) function compare_reals(a,b) bind(c)
         real(c_float) :: a,b
         if(a>b) then 
             compare_reals=1
         else if(a<b) then
             compare_reals=-1
         else
             compare_reals=0
         endif
     end function compare_reals
end module qsort_c_to_fortran

program test_qsort_c

    use qsort_c_to_fortran
    
    integer(c_size_t), parameter :: n=7
    real(c_float), pointer :: a(:) 
    
    allocate(a(n))
    call random_number(a)
    print*,'Unordered a: '
    print*,a
    
    call qsort(c_loc(a(1)), n, c_sizeof(a(1)), c_funloc(compare_reals));
    
    print*,'Ordered a: '
    print*,a

end program test_qsort_c
